%define version 2000c
%define fversion 2000c
%define release 7mdk
%define url ftp://ftp.cac.washington.edu/mail

Summary:	Server daemons for IMAP and POP network mail protocols.
Name:		imap
Version:	%{version}
Release:	%{release}
License:	BSD
Group:		System/Servers
Source:		%{url}/old/imap-%{fversion}.tar.bz2
Source1:	imap.pamd
Source2:	imap-xinetd
Source3:	ipop3-xinetd
Source4:	ipop2-xinetd
Source5:	imaps-xinetd
Source6:	pop3s-xinetd
Source7:	flock.c
Source8:	imap-sslcert
Patch0: 	imap-2000c-ssl.patch.bz2
Patch1: 	imap-2000-linux.patch.bz2
Patch2: 	imap-2000-vfs.patch.bz2
Patch3: 	imap-2000-redhat.patch.bz2
Patch4: 	imap-2000c-flock.patch.bz2
Patch7: 	imap-2000c-version.patch.bz2
Patch8: 	pine-4.30-boguswarning.patch.bz2
Patch9:		imap-2000-glibc-2.2.2.patch.bz2
Patch10:	imap-2000-ssldocs.patch.bz2
Patch11:	imap-2000c-security.patch.bz2
Patch12:	imap-2000c-morefixes.patch.bz2

Buildroot:	%{_tmppath}/%{name}-buildroot
Requires:	pam >= 0.59
BuildPreReq:	openssl-devel
BuildRequires:	pam-devel
Url:		http://www.washington.edu/imap/
Epoch:		1

%description
The imap package provides server daemons for both the IMAP (Internet
Message Access Protocol) and POP (Post Office Protocol) mail access
protocols.  The POP protocol uses a "post office" machine to collect mail
for users and allows users to download their mail to their local machine
for reading. The IMAP protocol provides the functionality of POP, but
allows a user to read mail on a remote machine without downloading it to
their local machine.

Install the imap package if you need a server to support the IMAP or the
POP mail access protocols.

%package devel
Summary:	Libraries, includes, etc to develop IMAP applications
Group:		Development/C
Requires:	imap = %version-%release

%description devel
The imap-devel package contains the header files and static libraries for
developing programs which will use the IMAP (Internet Message Access
Protocol) library.

%prep

%setup -q -n %{name}-%{fversion}
%patch0 -p1 -b .ssl
%patch1 -p1 -b .linxu
%patch2 -p1 -b .vfs
%patch3 -p1 -b .redhat
%patch4 -p1 -b .flock
%patch7 -p1 -b .version
%patch8 -p2 -b .boguswarning
cp %{SOURCE7} src/osdep/unix/
%patch9 -p1
%patch10 -p1
%patch11 -p1 -b .security
%patch12 -p1 -b .morefixes

%build
EXTRACFLAGS="$EXTRACFLAGS -I%_includedir/openssl"
##% make RPM_OPT_FLAGS="$RPM_OPT_FLAGS -DIGNORE_LOCK_EACCES_ERRORS -DPIC -fPIC" phall
%make RPM_OPT_FLAGS="%optflags -fPIC -fno-omit-frame-pointer" lnp EXTRACFLAGS="$EXTRACFLAGS" \
	SPECIALAUTHENTICATORS=ssl
mv -f ./ipopd/ipop3d ipop3sd
mv -f ./imapd/imapd imapsd
make clean
# rebuild without SSL support so to use different libwrapper entries.
%make RPM_OPT_FLAGS="%optflags -fPIC -fno-omit-frame-pointer" lnp EXTRACFLAGS="$EXTRACFLAGS"

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man8
install -m 644 ./src/ipopd/ipopd.8c $RPM_BUILD_ROOT%{_mandir}/man8/ipopd.8c
install -m 644 ./src/imapd/imapd.8c $RPM_BUILD_ROOT%{_mandir}/man8/imapd.8c

mkdir -p %buildroot/%_sbindir
install -s -m 755 ./ipopd/ipop2d $RPM_BUILD_ROOT/%_sbindir
install -s -m 755 ./ipopd/ipop3d $RPM_BUILD_ROOT/%_sbindir
install -s -m 755 ./imapd/imapd $RPM_BUILD_ROOT/%_sbindir
install -s -m 755 ./ipop3sd $RPM_BUILD_ROOT/%_sbindir
install -s -m 755 ./imapsd $RPM_BUILD_ROOT/%_sbindir

mkdir -p $RPM_BUILD_ROOT/%_sysconfdir/pam.d
install -m 644 ${RPM_SOURCE_DIR}/imap.pamd $RPM_BUILD_ROOT/%_sysconfdir/pam.d/imap
install -m 644 ${RPM_SOURCE_DIR}/imap.pamd $RPM_BUILD_ROOT/%_sysconfdir/pam.d/pop

mkdir -p %buildroot/%_libdir
#install -m 755 c-client/libimap.so.%{version} $RPM_BUILD_ROOT/usr/lib
#ln -s libimap.so.%{version} $RPM_BUILD_ROOT/usr/lib/libimap.so.4
#ln -s libimap.so.%{version} $RPM_BUILD_ROOT/usr/lib/libimap.so

#devel
mkdir -p %buildroot/%_includedir/imap
install -m 644 ./c-client/*.h %buildroot/%_includedir/imap
install -m 644 ./c-client/c-client.a %buildroot/%_libdir/libc-client.a
install -m 644 ./src/osdep/tops-20/shortsym.h %buildroot/%_includedir/imap

#xinetd
install -D -m644 %{SOURCE2} %buildroot/%_sysconfdir/xinetd.d/imap
install -D -m644 %{SOURCE3} %buildroot/%_sysconfdir/xinetd.d/ipop3
install -D -m644 %{SOURCE4} %buildroot/%_sysconfdir/xinetd.d/ipop2
install -D -m644 %{SOURCE5} %buildroot/%_sysconfdir/xinetd.d/imaps
install -D -m644 %{SOURCE6} %buildroot/%_sysconfdir/xinetd.d/pop3s

# Geoff: finally we install the cert to make ssl work by default.
mkdir -p $RPM_BUILD_ROOT%{_datadir}/ssl/certs
install %SOURCE8 $RPM_BUILD_ROOT%{_datadir}/ssl/certs/ipop3sd.pem
install %SOURCE8 $RPM_BUILD_ROOT%{_datadir}/ssl/certs/imapsd.pem

%clean
rm -rf $RPM_BUILD_ROOT

%post
[ -x /etc/init.d/xinetd ] && /etc/init.d/xinetd condrestart 2>/dev/null >/dev/null
exit 0

%postun
[ -x /etc/init.d/xinetd ] && /etc/init.d/xinetd condrestart 2>/dev/null >/dev/null
exit 0

%files
%defattr(-,root,root)
%config(noreplace) %_sysconfdir/xinetd.d/ipop2
%config(noreplace) %_sysconfdir/xinetd.d/ipop3
%config(noreplace) %_sysconfdir/xinetd.d/pop3s
%config(noreplace) %_sysconfdir/xinetd.d/imap
%config(noreplace) %_sysconfdir/xinetd.d/imaps
%config(noreplace) %_sysconfdir/pam.d/imap
%config(noreplace) %_sysconfdir/pam.d/pop
%attr(0700,root,root)%dir %_datadir/ssl/certs
%attr(0600,root,root)%config(noreplace) %_datadir/ssl/certs/*
%{_mandir}/man8/ipopd.8c*
%{_mandir}/man8/imapd.8c*
#/usr/lib/libimap.so*
%attr(0755,root,mail) %_sbindir/ipop2d
%attr(0755,root,mail) %_sbindir/ipop3d
%attr(0755,root,mail) %_sbindir/ipop3sd
%attr(0755,root,mail) %_sbindir/imapd
%attr(0755,root,mail) %_sbindir/imapsd
%doc README CPYRIGHT
%doc docs/*

%files devel
%defattr(-,root,root)
%_includedir/imap
%_libdir/libc-client.a

%changelog
* Mon Jun 18 2001 Stefan van der Eijk <stefan@eijk.nu> 2000c-7mdk
- BuildRequires:	pam-devel

* Fri Jun 02 2001 Geoffrey Lee <snailtalk@mandrakesoft.com> 2000c-6mdk
- Fix directory cpio problem, stupid typo (Vincent Myer).

* Fri Jun 01 2001 Geoffrey Lee <snailtalk@mandrakesoft.com> 2000c-5mdk
- Really make SSL work by default (Yes I admit that I really suck).

* Wed May 30 2001 Vincent Danen <vdanen@mandrakesoft.com> 2000c-4mdk
- security patches

* Fri May 18 2001 Geoffrey Lee <snailtalk@mandrakesoft.com> 2000c-3mdk
- Really make SSL connections work by default.

* Fri May 18 2001 Geoffrey Lee <snailtalk@mandrakesoft.com> 2000c-2mdk
- Make pop3s and imaps work by default by installing a defualt certificate,
  ripped shamelessly from the mod_ssl package.
  
* Wed Apr 11 2001 Giuseppe Ghib <ghibo@mandrakesoft.com> 2000c-1mdk
- updated to version 2000c (bugfixes).
- removed setcred patch (now included).
- removed sparc patch (now included).
- re-adapted -flock and -version patches to release 2000c.

* Tue Mar 15 2001 Giuseppe Ghib <ghibo@mandrakesoft.com> 2000-6mdk
- build with -fno-omit-frame-pointer for libsafe.
- fixed SSLBUILD docs.

* Wed Mar 14 2001 Giuseppe Ghib <ghibo@mandrakesoft.com> 2000-5mdk
- renamed ipop3d and imapd with SSL support to ipop3sd and imapsd, so
  that different libwrapper (i.e. /etc/hosts.deny|allow) entries can be
  used (e.g. one can allow remote SSL imapd and allow imap only for
  localhost, e.g. because needed for a WebMailer like horde IMP).

* Sat Mar 03 2001 Giuseppe Ghib <ghibo@mandrakesoft.com> 2000-4mdk
- fixed a typo in the SPEC file. Now imap2000 really supports
  SSL.
- bzip2 patches.

* Fri Mar 02 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2000-3mdk
- Adjust version as required by the License.
- Fix glibc-2.2.2 compilation.

* Thu Jan 11 2001 David BAUDENS <baudens@mandrakesoft.com> 2000-2mdk
- Don't apply sparc patch on non sparc archs (so, fix PPC build)
- %%config(noreplace)
- Macros

* Fri Nov 10 2000 Vincent Danen <vdanen@mandrakesoft.com> 2000-1mdk
- 2000
- change -devel description
- include SSL support
- fixed xinetd support for ipop2 (was using ipop3 for ipop2 incorrectly)

* Tue Sep 26 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.7c2-4mdk
- Pamstackizification.

* Sat Sep 23 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.7c2-3mdk
- Correct xinetd scripts.
- Add xinetd support for imap.

* Sun Sep 17 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.7c2-2mdk
- Fix bad link.

* Tue Jul 18 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 4.7c2-1mdk
- BM.
- xinetd support.
- Merge rh patches.
- 4.7c2.
- Clean up sepcs.

* Sun Apr 02 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 4.7b_virtual-2mdk
- fixed group

* Thu Mar 02 2000 Jean-Michel Dault <jmdault@netrevolution.com> 4.7b_virtual-1mdk
- updated to 4.7b

* Tue Feb 29 2000 Jean-Michel Dault <jmdault@netrevolution.com> 4.7a_virtual-3mdk
- A fix for crashes caused by certain unusual tokens in message headers. 
- updated patch

* Mon Feb 28 2000 Jean-Michel Dault <jmdault@netrevolution.com> 4.7a_virtual-2mdk
- moved docs in main package instead of devel

* Mon Feb 28 2000 Jean-Michel Dault <jmdault@netrevolution.com> 4.7a_virtual-1mdk
- upgraded to 4.7a
- added phall virtual patch for Linuxconf

* Mon Jan  3 2000 Jean-Michel Dault <jmdault@netrevolution.com>
- final cleanup for Mandrake 7

* Wed Dec 31 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- rebuild for Mandrake 7

* Sat Dec 12 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- Took mandrake adaptations (except SMP build) from 4.5-6mdk and updated to
  4.7. Now we have imap-devel
- Merged and re-made patch files

* Thu May 20 1999 Brian Bruns <bruns@magenet.com>
- Built on RH 5.2

* Thu May 20 1999 Henri Gomez <gomez@slib.fr>
- added devel package and libimap support

* Fri May 14 1999 Brian Bruns <bruns@magenet.com>
- Update to IMAP 4.6 beta

* Fri Apr 09 1999 Cristian Gafton <gafton@redhat.com>
- ipop3d service name was changed to "pop" now. Clearly somebody that hasn't
  got a clue about PAM stuff is messing around with the source.

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 2)

* Sat Mar 13 1999 Cristian Gafton <gafton@redhat.com>
- verson 4.5
- loose the noflock patch

* Thu Dec 17 1998 Cristian Gafton <gafton@redhat.com>
- added a -vfs patch because sys/statvfs on glibc 2.1 is different from what
  is available on the sun...
- build against glibc 2.1

* Fri Sep 11 1998 Jeff Johnson <jbj@redhat.com>
- use only fcntl locking.

* Thu Sep 10 1998 Jeff Johnson <jbj@redhat.com>
- update to 4.4.
- removed g+s bit to imapd.

* Wed Jul 22 1998 Jeff Johnson <jbj@redhat.com>
- updated to 4.2.
- added g+s bit to imapd so that lock files can be created.

* Thu May 07 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed Apr 08 1998 Cristian Gafton <gafton@redhat.com>
- Updated to the latest imap as of today...

* Wed Dec 10 1997 Cristian Gafton <gafton@redhat.com>
- Updated to the latest imap as of today...
- Updated the pam patch to reflect the new directory organization

* Thu Oct 23 1997 Michael K. Johnson <johnsonm@redhat.com>
- Fix patch for new PAM spec compliance.

* Thu Oct 02 1997 Michael K. Johnson <johnsonm@redhat.com>
- Comply with change in PAM spec.
- Use a buildroot.

* Mon Mar 03 1997 Michael K. Johnson <johnsonm@redhat.com>
- Moved from pam.conf to pam.d

* Mon Mar 03 1997 Erik Troan <ewt@redhat.com>
- Fixed buffer overrun in server_login().
